//Created Date:2012/07/23 15:43
namespace SensorTechnology {
	namespace StCam {
		using namespace System;
		using namespace System::Runtime::InteropServices;
		typedef void* HANDLE;
		public __delegate void fStCamPreviewBitmapCallbackFunc(unsigned char* pbyteBitmap,unsigned int dwBufferSize, unsigned int dwWidth, unsigned int dwHeight, unsigned int dwFrameNo, unsigned int dwPreviewPixelFormat, System::IntPtr lpContext,System::IntPtr lpReserved);
		public __delegate void fStCamRawCallbackFunc(unsigned char* pbyteBuffer,unsigned int dwBufferSize, unsigned int dwWidth, unsigned int dwHeight, unsigned int dwFrameNo,unsigned short wColorArray, unsigned int dwTransferBitsPerPixel, System::IntPtr lpContext,System::IntPtr lpReserved);
		public __delegate void fStCamPreviewGDICallbackFunc(System::IntPtr hDC, unsigned int dwWidth, unsigned int dwHeight,  unsigned int dwFrameNo,System::IntPtr lpContext,System::IntPtr lpReserved);
		//------------------------------------------------------------------------------
		//Function
		//------------------------------------------------------------------------------

		//------------------------------------------------------------------------------
		//Initialize
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_Open")]
		extern "C" HANDLE Open(unsigned int dwInstance);
		[DllImport("StCamD.dll", EntryPoint="StCam_Close")]
		extern "C" void Close(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetLastError")]
		extern "C" unsigned int GetLastError(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_CameraCount")]
		extern "C" unsigned int CameraCount();
		[DllImport("StCamD.dll", EntryPoint="StCam_SetReceiveMsgWindow")]
		extern "C" bool SetReceiveMsgWindow(HANDLE hCamera, System::IntPtr hWnd);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetUSBSpeed")]
		extern "C" bool GetUSBSpeed(HANDLE hCamera, unsigned char* pbyteUSBSpeed);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetUSBMaxSpeed")]
		extern "C" bool GetUSBMaxSpeed(HANDLE hCamera, unsigned char* pbyteUSBSpeed);

		//------------------------------------------------------------------------------
		//Image Information
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetColorArray")]
		extern "C" bool GetColorArray(HANDLE hCamera, unsigned short* pwColorArray);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnableTransferBitsPerPixel")]
		extern "C" bool GetEnableTransferBitsPerPixel(HANDLE hCamera, unsigned int* pdwEnableTransferBitsPerPixel);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetTransferBitsPerPixel")]
		extern "C" bool SetTransferBitsPerPixel(HANDLE hCamera, unsigned int dwTransferBitsPerPixel);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetTransferBitsPerPixel")]
		extern "C" bool GetTransferBitsPerPixel(HANDLE hCamera, unsigned int* pdwTransferBitsPerPixel);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMaximumImageSize")]
		extern "C" bool GetMaximumImageSize(HANDLE hCamera, unsigned int* pdwMaxWidth, unsigned int* pdwMaxHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnableImageSize")]
		extern "C" bool GetEnableImageSize(HANDLE hCamera, unsigned int* pdwReserved, unsigned short* pwEnableScanMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetImageSize")]
		extern "C" bool SetImageSize(HANDLE hCamera, unsigned int dwReserved, unsigned short wScanMode, unsigned int dwOffsetX, unsigned int dwOffsetY, unsigned int dwWidth, unsigned int dwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetImageSize")]
		extern "C" bool GetImageSize(HANDLE hCamera, unsigned int* pdwReserved, unsigned short* pwScanMode, unsigned int* pdwOffsetX, unsigned int* pdwOffsetY, unsigned int* pdwWidth, unsigned int* pdwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetSkippingAndBinning")]
		extern "C" bool GetSkippingAndBinning(HANDLE hCamera, unsigned char* pbyteHSkipping, unsigned char* pbyteVSkipping, unsigned char* pbyteHBinning, unsigned char* pbyteVBinning);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetSkippingAndBinning")]
		extern "C" bool SetSkippingAndBinning(HANDLE hCamera, unsigned char byteHSkipping, unsigned char byteVSkipping, unsigned char byteHBinning, unsigned char byteVBinning);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetBinningSumMode")]
		extern "C" bool GetBinningSumMode(HANDLE hCamera, unsigned short* pwMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetBinningSumMode")]
		extern "C" bool SetBinningSumMode(HANDLE hCamera, unsigned short wMode);

		//------------------------------------------------------------------------------
		//Preview
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_StartTransfer")]
		extern "C" bool StartTransfer(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_StopTransfer")]
		extern "C" bool StopTransfer(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetPreviewPixelFormat")]
		extern "C" bool SetPreviewPixelFormat(HANDLE hCamera, unsigned int dwPreviewPixelFormat);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewPixelFormat")]
		extern "C" bool GetPreviewPixelFormat(HANDLE hCamera, unsigned int* pdwPreviewPixelFormat);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnablePreviewPixelFormat")]
		extern "C" bool GetEnablePreviewPixelFormat(HANDLE hCamera, unsigned int* pdwEnablePreviewPixelFormat);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetColorInterpolationMethod")]
		extern "C" bool SetColorInterpolationMethod(HANDLE hCamera, unsigned char byteColorInterpolationMethod);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetColorInterpolationMethod")]
		extern "C" bool GetColorInterpolationMethod(HANDLE hCamera, unsigned char* pbyteColorInterpolationMethod);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_CreatePreviewWindowA")]
		extern "C" bool CreatePreviewWindowA(HANDLE hCamera, String* pszWindowName, unsigned int dwStyle, int lngPositionX, int lngPositionY, unsigned int dwWidth, unsigned int dwHeight, System::IntPtr hWndParent, System::IntPtr hMenu, bool bCloseEnable);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_CreatePreviewWindowW")]
		extern "C" bool CreatePreviewWindowW(HANDLE hCamera, String* pszWindowName, unsigned int dwStyle, int lngPositionX, int lngPositionY, unsigned int dwWidth, unsigned int dwHeight, System::IntPtr hWndParent, System::IntPtr hMenu, bool bCloseEnable);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_CreatePreviewWindow")]
		extern "C" bool CreatePreviewWindow(HANDLE hCamera, String* pszWindowName, unsigned int dwStyle, int lngPositionX, int lngPositionY, unsigned int dwWidth, unsigned int dwHeight, System::IntPtr hWndParent, System::IntPtr hMenu, bool bCloseEnable);
		[DllImport("StCamD.dll", EntryPoint="StCam_DestroyPreviewWindow")]
		extern "C" bool DestroyPreviewWindow(HANDLE hCamera);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_SetPreviewWindowNameA")]
		extern "C" bool SetPreviewWindowNameA(HANDLE hCamera, String* pszWindowName);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_GetPreviewWindowNameA")]
		extern "C" bool GetPreviewWindowNameA(HANDLE hCamera, System::Text::StringBuilder* pszWindowName, int lngMaxCount);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_SetPreviewWindowNameW")]
		extern "C" bool SetPreviewWindowNameW(HANDLE hCamera, String* pszWindowName);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_SetPreviewWindowName")]
		extern "C" bool SetPreviewWindowName(HANDLE hCamera, String* pszWindowName);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_GetPreviewWindowNameW")]
		extern "C" bool GetPreviewWindowNameW(HANDLE hCamera, System::Text::StringBuilder* pszWindowName, int lngMaxCount);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_GetPreviewWindowName")]
		extern "C" bool GetPreviewWindowName(HANDLE hCamera, System::Text::StringBuilder* pszWindowName, int lngMaxCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetPreviewMaskSize")]
		extern "C" bool SetPreviewMaskSize(HANDLE hCamera, unsigned int dwOffsetX, unsigned int dwOffsetY, unsigned int dwWidth, unsigned int dwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewMaskSize")]
		extern "C" bool GetPreviewMaskSize(HANDLE hCamera, unsigned int* pdwOffsetX, unsigned int* pdwOffsetY, unsigned int* pdwWidth, unsigned int* pdwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetPreviewWindowSize")]
		extern "C" bool SetPreviewWindowSize(HANDLE hCamera, int lngPositionX, int lngPositionY, unsigned int dwWidth, unsigned int dwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewWindowSize")]
		extern "C" bool GetPreviewWindowSize(HANDLE hCamera, int* plngPositionX, int* plngPositionY, unsigned int* pdwWidth, unsigned int* pdwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetPreviewWindowStyle")]
		extern "C" bool SetPreviewWindowStyle(HANDLE hCamera, unsigned int dwStyle);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewWindowStyle")]
		extern "C" bool GetPreviewWindowStyle(HANDLE hCamera, unsigned int* pdwStyle);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAspectMode")]
		extern "C" bool SetAspectMode(HANDLE hCamera, unsigned char byteAspectMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAspectMode")]
		extern "C" bool GetAspectMode(HANDLE hCamera, unsigned char* pbyteAspectMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetPreviewDestSize")]
		extern "C" bool SetPreviewDestSize(HANDLE hCamera, unsigned int dwOffsetX, unsigned int dwOffsetY, unsigned int dwWidth, unsigned int dwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewDestSize")]
		extern "C" bool GetPreviewDestSize(HANDLE hCamera, unsigned int* pdwOffsetX, unsigned int* pdwOffsetY, unsigned int* pdwWidth, unsigned int* pdwHeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetMagnificationMode")]
		extern "C" bool SetMagnificationMode(HANDLE hCamera, unsigned char byteMagnificationMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMagnificationMode")]
		extern "C" bool GetMagnificationMode(HANDLE hCamera, unsigned char* pbyteMagnificationMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDC")]
		extern "C" bool GetDC(HANDLE hCamera, System::IntPtr phDC);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDCWithReset")]
		extern "C" bool GetDCWithReset(HANDLE hCamera, System::IntPtr phDC);
		[DllImport("StCamD.dll", EntryPoint="StCam_ReleaseDC")]
		extern "C" bool ReleaseDC(HANDLE hCamera, System::IntPtr hDC);
		[DllImport("StCamD.dll", EntryPoint="StCam_ResetOverlay")]
		extern "C" bool ResetOverlay(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetColorKey")]
		extern "C" bool SetColorKey(HANDLE hCamera, unsigned int dwColorKey);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetColorKey")]
		extern "C" bool GetColorKey(HANDLE hCamera, unsigned int* pdwColorKey);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetDisplayMode")]
		extern "C" bool SetDisplayMode(HANDLE hCamera, unsigned char byteDisplayMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDisplayMode")]
		extern "C" bool GetDisplayMode(HANDLE hCamera, unsigned char* pbyteDisplayMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAlphaChannel")]
		extern "C" bool GetAlphaChannel(HANDLE hCamera, unsigned char* pbyteAlphaChannel);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAlphaChannel")]
		extern "C" bool SetAlphaChannel(HANDLE hCamera, unsigned char byteAlphaChannel);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewImagePixelValue")]
		extern "C" bool GetPreviewImagePixelValue(HANDLE hCamera, unsigned int nX, unsigned int nY, unsigned int* pdwColor);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewWnd")]
		extern "C" bool GetPreviewWnd(HANDLE hCamera, System::IntPtr hWnd);

		//------------------------------------------------------------------------------
		//Image Acquisition
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_TakeRawSnapShot")]
		extern "C" bool TakeRawSnapShot(HANDLE hCamera, unsigned char* pbyteBuffer, unsigned int dwBufferSize, unsigned int* pdwNumberOfByteTrans, unsigned int* pdwFrameNo, unsigned int dwMilliseconds);
		[DllImport("StCamD.dll", EntryPoint="StCam_TakePreviewSnapShot")]
		extern "C" bool TakePreviewSnapShot(HANDLE hCamera, unsigned char* pbyteBuffer, unsigned int dwBufferSize, unsigned int* pdwNumberOfByteTrans, unsigned int* pdwFrameNo, unsigned int dwMilliseconds);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_SaveImageA")]
		extern "C" bool SaveImageA(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned int dwPreviewPixelFormat, unsigned char* pbyteData, String* pszFileName, unsigned int dwParam);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_SaveImageW")]
		extern "C" bool SaveImageW(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned int dwPreviewPixelFormat, unsigned char* pbyteData, String* pszFileName, unsigned int dwParam);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_SaveImage")]
		extern "C" bool SaveImage(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned int dwPreviewPixelFormat, unsigned char* pbyteData, String* pszFileName, unsigned int dwParam);

		//------------------------------------------------------------------------------
		//Shutter Gain Control
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetALCMode")]
		extern "C" bool GetALCMode(HANDLE hCamera, unsigned char* pbyteAlcMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetALCMode")]
		extern "C" bool SetALCMode(HANDLE hCamera, unsigned char byteAlcMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetExposureClock")]
		extern "C" bool GetExposureClock(HANDLE hCamera, unsigned int* pdwExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetExposureClock")]
		extern "C" bool SetExposureClock(HANDLE hCamera, unsigned int dwExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMaxShortExposureClock")]
		extern "C" bool GetMaxShortExposureClock(HANDLE hCamera, unsigned int* pdwMaximumExpClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMaxLongExposureClock")]
		extern "C" bool GetMaxLongExposureClock(HANDLE hCamera, unsigned int* pdwMaximumExpClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetExposureTimeFromClock")]
		extern "C" bool GetExposureTimeFromClock(HANDLE hCamera, unsigned int dwExposureClock, float* pfExpTime);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetExposureClockFromTime")]
		extern "C" bool GetExposureClockFromTime(HANDLE hCamera, float fExpTime, unsigned int* pdwExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetGain")]
		extern "C" bool GetGain(HANDLE hCamera, unsigned short* pwGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetGain")]
		extern "C" bool SetGain(HANDLE hCamera, unsigned short wGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMaxGain")]
		extern "C" bool GetMaxGain(HANDLE hCamera, unsigned short* pwMaxGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetGainDBFromSettingValue")]
		extern "C" bool GetGainDBFromSettingValue(HANDLE hCamera, unsigned short wGain, float* pfGainDB);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetTargetBrightness")]
		extern "C" bool GetTargetBrightness(HANDLE hCamera, unsigned char* pbyteTargetBrightness, unsigned char* pbyteTolerance, unsigned char* pbyteThreshold);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetTargetBrightness")]
		extern "C" bool SetTargetBrightness(HANDLE hCamera, unsigned char byteTargetBrightness, unsigned char byteTolerance, unsigned char byteThreshold);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetALCWeight")]
		extern "C" bool GetALCWeight(HANDLE hCamera, unsigned char* pbyteALCWeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetALCWeight")]
		extern "C" bool SetALCWeight(HANDLE hCamera, unsigned char* pbyteALCWeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAEMinExposureClock")]
		extern "C" bool SetAEMinExposureClock(HANDLE hCamera, unsigned int dwMinExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAEMinExposureClock")]
		extern "C" bool GetAEMinExposureClock(HANDLE hCamera, unsigned int* pdwMinExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAEMaxExposureClock")]
		extern "C" bool GetAEMaxExposureClock(HANDLE hCamera, unsigned int* pdwMaxExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAEMaxExposureClock")]
		extern "C" bool SetAEMaxExposureClock(HANDLE hCamera, unsigned int dwMaxExposureClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetALCControlSpeed")]
		extern "C" bool SetALCControlSpeed(HANDLE hCamera, unsigned char byteShutterCtrlSpeedLimit, unsigned char byteGainCtrlSpeedLimit, unsigned char byteSkipFrameCount, unsigned char byteAverageFrameCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetALCControlSpeed")]
		extern "C" bool GetALCControlSpeed(HANDLE hCamera, unsigned char* pbyteShutterCtrlSpeedLimit, unsigned char* pbyteGainCtrlSpeedLimit, unsigned char* pbyteSkipFrameCount, unsigned char* pbyteAverageFrameCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetGainControlRange")]
		extern "C" bool GetGainControlRange(HANDLE hCamera, unsigned short* pwMinGain, unsigned short* pwMaxGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetGainControlRange")]
		extern "C" bool SetGainControlRange(HANDLE hCamera, unsigned short wMinGain, unsigned short wMaxGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDigitalGain")]
		extern "C" bool GetDigitalGain(HANDLE hCamera, unsigned short* pwDigitalGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetDigitalGain")]
		extern "C" bool SetDigitalGain(HANDLE hCamera, unsigned short wDigitalGain);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetShutterSpeed")]
		extern "C" bool GetShutterSpeed(HANDLE hCamera, unsigned short* pwShutterLine, unsigned short* pwShutterClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetShutterSpeed")]
		extern "C" bool SetShutterSpeed(HANDLE hCamera, unsigned short wShutterLine, unsigned short wShutterClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetShutterControlRange")]
		extern "C" bool GetShutterControlRange(HANDLE hCamera, unsigned short* pwMinShutterLine, unsigned short* pwMinShutterClock, unsigned short* pwMaxShutterLine, unsigned short* pwMaxShutterClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetShutterControlRange")]
		extern "C" bool SetShutterControlRange(HANDLE hCamera, unsigned short wMinShutterLine, unsigned short wMinShutterClock, unsigned short wMaxShutterLine, unsigned short wMaxShutterClock);

		//------------------------------------------------------------------------------
		//White Balance Control
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_SetWhiteBalanceMode")]
		extern "C" bool SetWhiteBalanceMode(HANDLE hCamera, unsigned char byteWBMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetWhiteBalanceMode")]
		extern "C" bool GetWhiteBalanceMode(HANDLE hCamera, unsigned char* pbyteWBMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetWhiteBalanceGain")]
		extern "C" bool SetWhiteBalanceGain(HANDLE hCamera, unsigned short wWBGainR, unsigned short wWBGainGr, unsigned short wWBGainGb, unsigned short wWBGainB);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetWhiteBalanceGain")]
		extern "C" bool GetWhiteBalanceGain(HANDLE hCamera, unsigned short* pwWBGainR, unsigned short* pwWBGainGr, unsigned short* pwWBGainGb, unsigned short* pwWBGainB);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetWhiteBalanceTarget")]
		extern "C" bool SetWhiteBalanceTarget(HANDLE hCamera, unsigned short wAWBTargetR, unsigned short wAWBTargetB);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetWhiteBalanceTarget")]
		extern "C" bool GetWhiteBalanceTarget(HANDLE hCamera, unsigned short* pwAWBTargetR, unsigned short* pwAWBTargetB);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetWhiteBalanceToleranceThreshold")]
		extern "C" bool SetWhiteBalanceToleranceThreshold(HANDLE hCamera, unsigned short wAWBTolerance, unsigned short wAWBThreshold);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetWhiteBalanceToleranceThreshold")]
		extern "C" bool GetWhiteBalanceToleranceThreshold(HANDLE hCamera, unsigned short* pwAWBTolerance, unsigned short* pwAWBThreshold);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAWBWeight")]
		extern "C" bool SetAWBWeight(HANDLE hCamera, unsigned char* pbyteAWBWeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAWBWeight")]
		extern "C" bool GetAWBWeight(HANDLE hCamera, unsigned char* pbyteAWBWeight);
		[DllImport("StCamD.dll", EntryPoint="StCam_RawWhiteBalance")]
		extern "C" bool RawWhiteBalance(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned short wColorArray, unsigned char* pbyteRaw);

		//------------------------------------------------------------------------------
		//Gamma
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_SetGammaMode")]
		extern "C" bool SetGammaMode(HANDLE hCamera, unsigned char byteGammaTarget, unsigned char byteGammaMode, unsigned short wGamma, unsigned char* pbyteGammaTable);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetGammaMode")]
		extern "C" bool GetGammaMode(HANDLE hCamera, unsigned char byteGammaTarget, unsigned char* pbyteGammaMode, unsigned short* pwGamma, unsigned char* pbyteGammaTable);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetGammaModeEx")]
		extern "C" bool SetGammaModeEx(HANDLE hCamera, unsigned char byteGammaTarget, unsigned char byteGammaMode, unsigned short wGamma, short shtBrightness, unsigned char byteContrast, unsigned char* pbyteGammaTable);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetGammaModeEx")]
		extern "C" bool GetGammaModeEx(HANDLE hCamera, unsigned char byteGammaTarget, unsigned char* pbyteGammaMode, unsigned short* pwGamma, short* pshtBrightness, unsigned char* pbyteContrast, unsigned char* pbyteGammaTable);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetCameraGammaValue")]
		extern "C" bool GetCameraGammaValue(HANDLE hCamera, unsigned short* pwValue);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetCameraGammaValue")]
		extern "C" bool SetCameraGammaValue(HANDLE hCamera, unsigned short wValue);

		//------------------------------------------------------------------------------
		//Sharpness
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_SetSharpnessMode")]
		extern "C" bool SetSharpnessMode(HANDLE hCamera, unsigned char byteSharpnessMode, unsigned short wSharpnessGain, unsigned char byteSharpnessCoring);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetSharpnessMode")]
		extern "C" bool GetSharpnessMode(HANDLE hCamera, unsigned char* pbyteSharpnessMode, unsigned short* pwSharpnessGain, unsigned char* pbyteSharpnessCoring);

		//------------------------------------------------------------------------------
		//Hue Saturation
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_SetHueSaturationMode")]
		extern "C" bool SetHueSaturationMode(HANDLE hCamera, unsigned char byteHueSaturationMode, short shtHue, unsigned short wSaturation);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetHueSaturationMode")]
		extern "C" bool GetHueSaturationMode(HANDLE hCamera, unsigned char* pbyteHueSaturationMode, short* pshtHue, unsigned short* pwSaturation);

		//------------------------------------------------------------------------------
		//Color Matrix
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_SetColorMatrix")]
		extern "C" bool SetColorMatrix(HANDLE hCamera, unsigned char byteColorMatrixMode, short* pshtColorMatrix);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetColorMatrix")]
		extern "C" bool GetColorMatrix(HANDLE hCamera, unsigned char* pbyteColorMatrixMode, short* pshtColorMatrix);

		//------------------------------------------------------------------------------
		//Mirro Rotation
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnableMirrorMode")]
		extern "C" bool GetEnableMirrorMode(HANDLE hCamera, unsigned char* pbyteMirrorMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetMirrorMode")]
		extern "C" bool SetMirrorMode(HANDLE hCamera, unsigned char byteMirrorMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetMirrorMode")]
		extern "C" bool GetMirrorMode(HANDLE hCamera, unsigned char* pbyteMirrorMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetRotationMode")]
		extern "C" bool SetRotationMode(HANDLE hCamera, unsigned char byteRotationMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetRotationMode")]
		extern "C" bool GetRotationMode(HANDLE hCamera, unsigned char* pbyteRotationMode);

		//------------------------------------------------------------------------------
		//Movie
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_SaveAVIA")]
		extern "C" bool SaveAVIA(HANDLE hCamera, String* pszFileName, unsigned int dwCompressor, unsigned int dwLength, void* lpReserved);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_SaveAVIW")]
		extern "C" bool SaveAVIW(HANDLE hCamera, String* pszFileName, unsigned int dwCompressor, unsigned int dwLength, void* lpReserved);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_SaveAVI")]
		extern "C" bool SaveAVI(HANDLE hCamera, String* pszFileName, unsigned int dwCompressor, unsigned int dwLength, void* lpReserved);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAVIStatus")]
		extern "C" bool SetAVIStatus(HANDLE hCamera, unsigned char byteAVIStatus);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAVIStatus")]
		extern "C" bool GetAVIStatus(HANDLE hCamera, unsigned char* pbyteAVIStatus, unsigned int* pdwTotalFrameCounts, unsigned int* pdwCurrentFrameCounts);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetAVIQuality")]
		extern "C" bool SetAVIQuality(HANDLE hCamera, unsigned int dwQuality);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetAVIQuality")]
		extern "C" bool GetAVIQuality(HANDLE hCamera, unsigned int* pdwQuality);

		//------------------------------------------------------------------------------
		//Clock
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnableClock")]
		extern "C" bool GetEnableClock(HANDLE hCamera, unsigned int* pdwEnableClockMode, unsigned int* pdwStandardClock, unsigned int* pdwMinimumClock, unsigned int* pdwMaximumClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetClock")]
		extern "C" bool SetClock(HANDLE hCamera, unsigned int dwClockMode, unsigned int dwClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetClock")]
		extern "C" bool GetClock(HANDLE hCamera, unsigned int* pdwClockMode, unsigned int* pdwClock);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetFrameClock")]
		extern "C" bool GetFrameClock(HANDLE hCamera, unsigned short* pwCurrentLinePerFrame, unsigned short* pwCurrentClockPerLine);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetOutputFPS")]
		extern "C" bool GetOutputFPS(HANDLE hCamera, float* pfFPS);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetVBlankForFPS")]
		extern "C" bool SetVBlankForFPS(HANDLE hCamera, unsigned int dwVLines);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetVBlankForFPS")]
		extern "C" bool GetVBlankForFPS(HANDLE hCamera, unsigned int* pdwVLines);

		//------------------------------------------------------------------------------
		//Defect pixel correction
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetEnableDefectPixelCorrectionCount")]
		extern "C" bool GetEnableDefectPixelCorrectionCount(HANDLE hCamera, unsigned short* pwCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDefectPixelCorrectionMode")]
		extern "C" bool GetDefectPixelCorrectionMode(HANDLE hCamera, unsigned short* pwMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetDefectPixelCorrectionMode")]
		extern "C" bool SetDefectPixelCorrectionMode(HANDLE hCamera, unsigned short wMode);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDefectPixelCorrectionPosition")]
		extern "C" bool GetDefectPixelCorrectionPosition(HANDLE hCamera, unsigned short wIndex, unsigned int* pdwX, unsigned int* pdwY);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetDefectPixelCorrectionPosition")]
		extern "C" bool SetDefectPixelCorrectionPosition(HANDLE hCamera, unsigned short wIndex, unsigned int dwX, unsigned int dwY);
		[DllImport("StCamD.dll", EntryPoint="StCam_DetectDefectPixel")]
		extern "C" bool DetectDefectPixel(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned char* pbyteRaw, unsigned short wThreshold);

		//------------------------------------------------------------------------------
		//Callback Function
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_AddPreviewBitmapCallback")]
		extern "C" bool AddPreviewBitmapCallback(HANDLE hCamera, fStCamPreviewBitmapCallbackFunc* pPreviewBitmapCallbackFunc, void* pContext, unsigned int* pdwPreviewBitmapCallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemovePreviewBitmapCallback")]
		extern "C" bool RemovePreviewBitmapCallback(HANDLE hCamera, unsigned int dwPreviewBitmapCallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemoveAllPreviewBitmapCallback")]
		extern "C" bool RemoveAllPreviewBitmapCallback(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewBitmapCallbackCount")]
		extern "C" bool GetPreviewBitmapCallbackCount(HANDLE hCamera, unsigned int* pdwListCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewBitmapCallback")]
		extern "C" bool GetPreviewBitmapCallback(HANDLE hCamera, unsigned int dwCallbackIndex, fStCamPreviewBitmapCallbackFunc** ppPreviewBitmapCallbackFunc, unsigned int* pdwCallbackFunctionNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_AddPreviewGDICallback")]
		extern "C" bool AddPreviewGDICallback(HANDLE hCamera, fStCamPreviewGDICallbackFunc* pPreviewGDICallbackFunc, void* pContext, unsigned int* pdwPreviewGDICallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemovePreviewGDICallback")]
		extern "C" bool RemovePreviewGDICallback(HANDLE hCamera, unsigned int dwPreviewGDICallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemoveAllPreviewGDICallback")]
		extern "C" bool RemoveAllPreviewGDICallback(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewGDICallbackCount")]
		extern "C" bool GetPreviewGDICallbackCount(HANDLE hCamera, unsigned int* pdwListCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetPreviewGDICallback")]
		extern "C" bool GetPreviewGDICallback(HANDLE hCamera, unsigned int dwCallbackIndex, fStCamPreviewGDICallbackFunc** ppPreviewGDICallbackFunc, unsigned int* pdwCallbackFunctionNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_AddRawCallback")]
		extern "C" bool AddRawCallback(HANDLE hCamera, fStCamRawCallbackFunc* pRawCallbackFunc, void* pContext, unsigned int* pdwRawCallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemoveRawCallback")]
		extern "C" bool RemoveRawCallback(HANDLE hCamera, unsigned int dwRawCallbackNo);
		[DllImport("StCamD.dll", EntryPoint="StCam_RemoveAllRawCallback")]
		extern "C" bool RemoveAllRawCallback(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetRawCallbackCount")]
		extern "C" bool GetRawCallbackCount(HANDLE hCamera, unsigned int* pdwListCount);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetRawCallback")]
		extern "C" bool GetRawCallback(HANDLE hCamera, unsigned int dwCallbackIndex, fStCamRawCallbackFunc** ppRawCallbackFunc, unsigned int* pdwCallbackFunctionNo);

		//------------------------------------------------------------------------------
		//Setting
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_SaveSettingFileA")]
		extern "C" bool SaveSettingFileA(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_SaveSettingFileW")]
		extern "C" bool SaveSettingFileW(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_SaveSettingFile")]
		extern "C" bool SaveSettingFile(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_LoadSettingFileA")]
		extern "C" bool LoadSettingFileA(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_LoadSettingFileW")]
		extern "C" bool LoadSettingFileW(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_LoadSettingFile")]
		extern "C" bool LoadSettingFile(HANDLE hCamera, String* pszFileName);
		[DllImport("StCamD.dll", EntryPoint="StCam_ResetSetting")]
		extern "C" bool ResetSetting(HANDLE hCamera);
		[DllImport("StCamD.dll", EntryPoint="StCam_CameraSetting")]
		extern "C" bool CameraSetting(HANDLE hCamera, unsigned short wMode);

		//------------------------------------------------------------------------------
		//EEPROM
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_ReadUserMemory")]
		extern "C" bool ReadUserMemory(HANDLE hCamera, unsigned char* pbyteBuffer, unsigned short wOffset, unsigned short wLength);
		[DllImport("StCamD.dll", EntryPoint="StCam_WriteUserMemory")]
		extern "C" bool WriteUserMemory(HANDLE hCamera, unsigned char* pbyteBuffer, unsigned short wOffset, unsigned short wLength);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_ReadCameraUserIDA")]
		extern "C" bool ReadCameraUserIDA(HANDLE hCamera, unsigned int* pdwCameraID, System::Text::StringBuilder* pszBuffer, unsigned int dwBufferSize);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_ReadCameraUserIDW")]
		extern "C" bool ReadCameraUserIDW(HANDLE hCamera, unsigned int* pdwCameraID, System::Text::StringBuilder* pszBuffer, unsigned int dwBufferSize);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_ReadCameraUserID")]
		extern "C" bool ReadCameraUserID(HANDLE hCamera, unsigned int* pdwCameraID, System::Text::StringBuilder* pszBuffer, unsigned int dwBufferSize);
		[DllImport("StCamD.dll", CharSet=CharSet::Ansi, EntryPoint="StCam_WriteCameraUserIDA")]
		extern "C" bool WriteCameraUserIDA(HANDLE hCamera, unsigned int dwCameraID, String* pszBuffer, unsigned int dwBufferSize);
		[DllImport("StCamD.dll", CharSet=CharSet::Unicode, EntryPoint="StCam_WriteCameraUserIDW")]
		extern "C" bool WriteCameraUserIDW(HANDLE hCamera, unsigned int dwCameraID, String* pszBuffer, unsigned int dwBufferSize);
		[DllImport("StCamD.dll", CharSet=CharSet::Auto, EntryPoint="StCam_WriteCameraUserID")]
		extern "C" bool WriteCameraUserID(HANDLE hCamera, unsigned int dwCameraID, String* pszBuffer, unsigned int dwBufferSize);

		//------------------------------------------------------------------------------
		//Version Information
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_GetCameraVersion")]
		extern "C" bool GetCameraVersion(HANDLE hCamera, unsigned short* pwUSBVendorID, unsigned short* pwUSBProductID, unsigned short* pwFPGAVersion, unsigned short* pwFirmVersion);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDriverVersion")]
		extern "C" bool GetDriverVersion(HANDLE hCamera, unsigned int* pdwFileVersionMS, unsigned int* pdwFileVersionLS, unsigned int* pdwProductVersionMS, unsigned int* pdwProductVersionLS);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetUSBDllVersion")]
		extern "C" bool GetUSBDllVersion(unsigned int* pdwFileVersionMS, unsigned int* pdwFileVersionLS, unsigned int* pdwProductVersionMS, unsigned int* pdwProductVersionLS);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetCAMDllVersion")]
		extern "C" bool GetCAMDllVersion(unsigned int* pdwFileVersionMS, unsigned int* pdwFileVersionLS, unsigned int* pdwProductVersionMS, unsigned int* pdwProductVersionLS);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetUSBFunctionAddress")]
		extern "C" bool GetUSBFunctionAddress(HANDLE hCamera, unsigned char* pbyteUSBFunctionAddress);

		//------------------------------------------------------------------------------
		//Other
		//------------------------------------------------------------------------------
		[DllImport("StCamD.dll", EntryPoint="StCam_ConvertBitmapBGR24ToRGB24")]
		extern "C" bool ConvertBitmapBGR24ToRGB24(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned char* pbyteBitmap);
		[DllImport("StCamD.dll", EntryPoint="StCam_ConvertRawToBGR")]
		extern "C" bool ConvertRawToBGR(HANDLE hCamera, unsigned int dwWidth, unsigned int dwHeight, unsigned char* pbyteSrcRaw, unsigned char* pbyteDstBGR, unsigned char byteColorInterpolationMethod, unsigned int dwPreviewPixelFormat);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetControlArea")]
		extern "C" bool SetControlArea(HANDLE hCamera, unsigned short* pwSepalateX, unsigned short* pwSepalateY);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetControlArea")]
		extern "C" bool GetControlArea(HANDLE hCamera, unsigned short* pwSepalateX, unsigned short* pwSepalateY);
		[DllImport("StCamD.dll", EntryPoint="StCam_GetDigitalClamp")]
		extern "C" bool GetDigitalClamp(HANDLE hCamera, unsigned short* pwValue);
		[DllImport("StCamD.dll", EntryPoint="StCam_SetDigitalClamp")]
		extern "C" bool SetDigitalClamp(HANDLE hCamera, unsigned short wValue);
		//------------------------------------------------------------------------------
		//Const
		//------------------------------------------------------------------------------

		//------------------------------------------------------------------------------
		//ERROR_STCAM
		//------------------------------------------------------------------------------
		const unsigned int ERRST_NOT_FOUND_CAMERA = 0xE0000001;
		const unsigned int ERRST_ALL_CAMARA_OPENED = 0xE0000002;
		const unsigned int ERRST_INVALID_CAMERA_HANDLE = 0xE0000003;
		const unsigned int ERRST_INVALID_FUNCTION_RECEIVING = 0xE0000004;
		const unsigned int ERRST_USB_COMMAND_TRANSFER = 0xE0000005;
		const unsigned int ERRST_WINDOW_ALREADY_EXISTS = 0xE0000006;
		const unsigned int ERRST_WINDOW_DOES_NOT_EXISTS = 0xE0000007;
		const unsigned int ERRST_INVALID_FUNCTION_RECORDING = 0xE0000008;
		const unsigned int ERRST_AVI_STREAM = 0xE0000009;
		const unsigned int ERRST_AVI_NOCOMPRESSOR = 0xE000000A;
		const unsigned int ERRST_AVI_UNSUPPORTED = 0xE000000B;
		const unsigned int ERRST_AVI_DISK = 0xE000000C;
		const unsigned int ERRST_AVI_CANCELED = 0xE000000D;
		const unsigned int ERRST_AVI_WRITE = 0xE000000E;
		const unsigned int ERRST_INVALID_FILE_NAME = 0xE000000F;
		const unsigned int ERRST_FILE_OPEN = 0xE0000010;
		const unsigned int ERRST_FILE_WRITE = 0xE0000011;
		const unsigned int ERRST_NOT_SUPPORTED_FUNCTION = 0xE0000021;

		//------------------------------------------------------------------------------
		//WM_STCAM
		//------------------------------------------------------------------------------
		const int WM_STCAM_TRANSFER_START = 0xB001;
		const int WM_STCAM_TRANSFER_FINISH = 0xB002;
		const int WM_STCAM_PREVIEW_WINDOW_CREATE = 0xB003;
		const int WM_STCAM_PREVIEW_WINDOW_CLOSE = 0xB004;
		const int WM_STCAM_PREVIEW_WINDOW_RESIZE = 0xB005;
		const int WM_STCAM_PREVIEW_MASK_RESIZE = 0xB006;
		const int WM_STCAM_PREVIEW_DEST_RESIZE = 0xB007;
		const int WM_STCAM_AVI_FILE_START = 0xB008;
		const int WM_STCAM_AVI_FILE_FINISH = 0xB009;
		const int WM_STCAM_PREVIEW_MENU_COMMAND = 0xB00A;
		const int WM_STCAM_UPDATED_PREVIEW_IMAGE = 0xB00B;

		//------------------------------------------------------------------------------
		//COLOR_ARRAY
		//------------------------------------------------------------------------------
		const unsigned short STCAM_COLOR_ARRAY_MONO = 0x0001;
		const unsigned short STCAM_COLOR_ARRAY_RGGB = 0x0002;
		const unsigned short STCAM_COLOR_ARRAY_GRBG = 0x0003;
		const unsigned short STCAM_COLOR_ARRAY_GBRG = 0x0004;
		const unsigned short STCAM_COLOR_ARRAY_BGGR = 0x0005;

		//------------------------------------------------------------------------------
		//TRANSER_BITS_PER_PIXEL
		//------------------------------------------------------------------------------
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_RAW_08 = 0x00000001;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_RAW_10 = 0x00000002;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_RAW_12 = 0x00000004;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_RAW_14 = 0x00000008;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_RAW_16 = 0x00000010;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_MONO_08 = 0x00000020;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_MONO_10 = 0x00000040;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_MONO_12 = 0x00000080;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_MONO_14 = 0x00000100;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_MONO_16 = 0x00000200;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_BGR_08 = 0x00000400;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_BGR_10 = 0x00000800;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_08 = 0x00000001;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_10 = 0x00000002;
		const unsigned int STCAM_TRANSFER_BITS_PER_PIXEL_12 = 0x00000004;
		const unsigned int STCAM_TRANSER_BITS_PER_PIXEL_08 = 0x00000001;
		const unsigned int STCAM_TRANSER_BITS_PER_PIXEL_16 = 0x00000002;

		//------------------------------------------------------------------------------
		//IMAGE_SIZE_MODE
		//------------------------------------------------------------------------------
		const unsigned int STCAM_IMAGE_SIZE_MODE_CUSTOM = 0x00000001;
		const unsigned int STCAM_IMAGE_SIZE_MODE_VGA = 0x00000008;
		const unsigned int STCAM_IMAGE_SIZE_MODE_XGA = 0x00000020;
		const unsigned int STCAM_IMAGE_SIZE_MODE_QUAD_VGA = 0x00000080;
		const unsigned int STCAM_IMAGE_SIZE_MODE_SXGA = 0x00000100;
		const unsigned int STCAM_IMAGE_SIZE_MODE_UXGA = 0x00000400;

		//------------------------------------------------------------------------------
		//SCAN_MODE
		//------------------------------------------------------------------------------
		const unsigned short STCAM_SCAN_MODE_NORMAL = 0x0000;
		const unsigned short STCAM_SCAN_MODE_PARTIAL_2 = 0x0001;
		const unsigned short STCAM_SCAN_MODE_PARTIAL_4 = 0x0002;
		const unsigned short STCAM_SCAN_MODE_PARTIAL_1 = 0x0004;
		const unsigned short STCAM_SCAN_MODE_VARIABLE_PARTIAL = 0x0008;
		const unsigned short STCAM_SCAN_MODE_BINNING = 0x0010;
		const unsigned short STCAM_SCAN_MODE_BINNING_PARTIAL_1 = 0x0020;
		const unsigned short STCAM_SCAN_MODE_BINNING_PARTIAL_2 = 0x0040;
		const unsigned short STCAM_SCAN_MODE_BINNING_PARTIAL_4 = 0x0080;
		const unsigned short STCAM_SCAN_MODE_BINNING_VARIABLE_PARTIAL = 0x0100;
		const unsigned short STCAM_SCAN_MODE_AOI = 0x8000;

		//------------------------------------------------------------------------------
		//PIXEL_FORMAT
		//------------------------------------------------------------------------------
		const unsigned int STCAM_PIXEL_FORMAT_08_MONO_OR_RAW = 0x00000001;
		const unsigned int STCAM_PIXEL_FORMAT_24_BGR = 0x00000004;
		const unsigned int STCAM_PIXEL_FORMAT_32_BGR = 0x00000008;

		//------------------------------------------------------------------------------
		//COLOR_INTERPOLATION
		//------------------------------------------------------------------------------
		const unsigned char STCAM_COLOR_INTERPOLATION_NONE_MONO = 0;
		const unsigned char STCAM_COLOR_INTERPOLATION_NONE_COLOR = 1;
		const unsigned char STCAM_COLOR_INTERPOLATION_NEAREST_NEIGHBOR = 2;
		const unsigned char STCAM_COLOR_INTERPOLATION_BILINEAR = 3;
		const unsigned char STCAM_COLOR_INTERPOLATION_BILINEAR_FALSE_COLOR_REDUCTION = 5;
		const unsigned char STCAM_COLOR_INTERPOLATION_BICUBIC = 4;

		//------------------------------------------------------------------------------
		//ASPECT
		//------------------------------------------------------------------------------
		const unsigned char STCAM_ASPECT_MODE_FIXED = 0;
		const unsigned char STCAM_ASPECT_MODE_KEEP_ASPECT = 1;
		const unsigned char STCAM_ASPECT_MODE_ADJUST_WINDOW = 2;
		const unsigned char STCAM_ASPECT_MODE_MASK_SIZE = 3;
		const unsigned char STCAM_ASPECT_MODE_CUSTOM_OFFSET = 254;
		const unsigned char STCAM_ASPECT_MODE_CUSTOM_CENTER = 255;
		const unsigned char STCAM_ASPECT_MODE_CUSTOM = 255;

		//------------------------------------------------------------------------------
		//MAGNIFICATION
		//------------------------------------------------------------------------------
		const unsigned char STCAM_MAGNIFICATION_MODE_OFF = 0;
		const unsigned char STCAM_MAGNIFICATION_MODE_ON = 1;

		//------------------------------------------------------------------------------
		//ALCMODE
		//------------------------------------------------------------------------------
		const unsigned char STCAM_ALCMODE_FIXED_SHUTTER_AGC_OFF = 0;
		const unsigned char STCAM_ALCMODE_AUTO_SHUTTER_ON_AGC_ON = 1;
		const unsigned char STCAM_ALCMODE_AUTO_SHUTTER_ON_AGC_OFF = 2;
		const unsigned char STCAM_ALCMODE_FIXED_SHUTTER_AGC_ON = 3;
		const unsigned char STCAM_ALCMODE_AUTO_SHUTTER_AGC_ONESHOT = 4;
		const unsigned char STCAM_ALCMODE_AUTO_SHUTTER_ONESHOT_AGC_OFF = 5;
		const unsigned char STCAM_ALCMODE_FIXED_SHUTTER_AGC_ONESHOT = 6;
		const unsigned char STCAM_ALCMODE_CAMERA_AE_ON = 16;
		const unsigned char STCAM_ALCMODE_CAMERA_AGC_ON = 32;
		const unsigned char STCAM_ALCMODE_CAMERA_AE_AGC_ON = 48;
		const unsigned char STCAM_ALCMODE_ALC_FIXED_AGC_OFF = 0;
		const unsigned char STCAM_ALCMODE_ALC_FULLAUTO_AGC_ON = 1;
		const unsigned char STCAM_ALCMODE_ALC_FULLAUTO_AGC_OFF = 2;
		const unsigned char STCAM_ALCMODE_ALC_FIXED_AGC_ON = 3;
		const unsigned char STCAM_ALCMODE_ALCAGC_ONESHOT = 4;
		const unsigned char STCAM_ALCMODE_ALC_ONESHOT_AGC_OFF = 5;
		const unsigned char STCAM_ALCMODE_ALC_FIXED_AGC_ONESHOT = 6;

		//------------------------------------------------------------------------------
		//WB
		//------------------------------------------------------------------------------
		const unsigned char STCAM_WB_OFF = 0;
		const unsigned char STCAM_WB_MANUAL = 1;
		const unsigned char STCAM_WB_FULLAUTO = 2;
		const unsigned char STCAM_WB_ONESHOT = 3;

		//------------------------------------------------------------------------------
		//GAMMA
		//------------------------------------------------------------------------------
		const unsigned char STCAM_GAMMA_OFF = 0;
		const unsigned char STCAM_GAMMA_ON = 1;
		const unsigned char STCAM_GAMMA_REVERSE = 2;
		const unsigned char STCAM_GAMMA_TABLE = 255;

		//------------------------------------------------------------------------------
		//GAMMA_TARGET
		//------------------------------------------------------------------------------
		const unsigned char STCAM_GAMMA_TARGET_Y = 0;
		const unsigned char STCAM_GAMMA_TARGET_R = 1;
		const unsigned char STCAM_GAMMA_TARGET_GR = 2;
		const unsigned char STCAM_GAMMA_TARGET_GB = 3;
		const unsigned char STCAM_GAMMA_TARGET_B = 4;

		//------------------------------------------------------------------------------
		//SHARPNESS
		//------------------------------------------------------------------------------
		const unsigned char STCAM_SHARPNESS_OFF = 0;
		const unsigned char STCAM_SHARPNESS_ON = 1;

		//------------------------------------------------------------------------------
		//HUE_SATURATION
		//------------------------------------------------------------------------------
		const unsigned char STCAM_HUE_SATURATION_OFF = 0;
		const unsigned char STCAM_HUE_SATURATION_ON = 1;

		//------------------------------------------------------------------------------
		//COLOR_MATRIX
		//------------------------------------------------------------------------------
		const unsigned char STCAM_COLOR_MATRIX_OFF = 0x00;
		const unsigned char STCAM_COLOR_MATRIX_CUSTOM = 0xFF;

		//------------------------------------------------------------------------------
		//MIRROR
		//------------------------------------------------------------------------------
		const unsigned char STCAM_MIRROR_OFF = 0;
		const unsigned char STCAM_MIRROR_HORIZONTAL = 1;
		const unsigned char STCAM_MIRROR_VERTICAL = 2;
		const unsigned char STCAM_MIRROR_HORIZONTAL_VERTICAL = 3;
		const unsigned char STCAM_MIRROR_HORIZONTAL_CAMERA = 16;
		const unsigned char STCAM_MIRROR_VERTICAL_CAMERA = 32;

		//------------------------------------------------------------------------------
		//ROTATION
		//------------------------------------------------------------------------------
		const unsigned char STCAM_ROTATION_OFF = 0;
		const unsigned char STCAM_ROTATION_CLOCKWISE_90 = 1;
		const unsigned char STCAM_ROTATION_COUNTERCLOCKWISE_90 = 2;

		//------------------------------------------------------------------------------
		//AVI_COMPRESSOR
		//------------------------------------------------------------------------------
		const unsigned int STCAM_AVI_COMPRESSOR_UNCOMPRESSED = 0x00000000;
		const unsigned int STCAM_AVI_COMPRESSOR_MJPG = 0x47504A4D;
		const unsigned int STCAM_AVI_COMPRESSOR_MP42 = 0x3234706D;
		const unsigned int STCAM_AVI_COMPRESSOR_MPV4 = 0x3467706D;
		const unsigned int STCAM_AVI_COMPRESSOR_DIALOG_BOX = 0xFFFFFFFF;

		//------------------------------------------------------------------------------
		//CLOCK_MODE
		//------------------------------------------------------------------------------
		const unsigned int STCAM_CLOCK_MODE_NORMAL = 0x00000000;
		const unsigned int STCAM_CLOCK_MODE_DIV_2 = 0x00000001;
		const unsigned int STCAM_CLOCK_MODE_DIV_4 = 0x00000002;
		const unsigned int STCAM_CLOCK_MODE_VGA_90FPS = 0x00000100;
		const unsigned int STCAM_CLOCK_MODE_CUSTOM = 0x80000000;

		//------------------------------------------------------------------------------
		//USBPID
		//------------------------------------------------------------------------------
		const unsigned short STCAM_USBPID_STC_C33USB = 0x0305;
		const unsigned short STCAM_USBPID_STC_B33USB = 0x0705;
		const unsigned short STCAM_USBPID_STC_B83USB = 0x0805;
		const unsigned short STCAM_USBPID_STC_C83USB = 0x0605;
		const unsigned short STCAM_USBPID_STC_TB33USB = 0x0906;
		const unsigned short STCAM_USBPID_STC_TC33USB = 0x1006;
		const unsigned short STCAM_USBPID_STC_TB83USB = 0x1106;
		const unsigned short STCAM_USBPID_STC_TC83USB = 0x1206;
		const unsigned short STCAM_USBPID_STC_TB133USB = 0x0109;
		const unsigned short STCAM_USBPID_STC_TC133USB = 0x0209;
		const unsigned short STCAM_USBPID_STC_TB152USB = 0x1306;
		const unsigned short STCAM_USBPID_STC_TC152USB = 0x1406;
		const unsigned short STCAM_USBPID_STC_TB202USB = 0x1506;
		const unsigned short STCAM_USBPID_STC_TC202USB = 0x1606;
		const unsigned short STCAM_USBPID_STC_MB33USB = 0x0110;
		const unsigned short STCAM_USBPID_STC_MC33USB = 0x0210;
		const unsigned short STCAM_USBPID_STC_MB83USB = 0x0310;
		const unsigned short STCAM_USBPID_STC_MC83USB = 0x0410;
		const unsigned short STCAM_USBPID_STC_MB133USB = 0x0510;
		const unsigned short STCAM_USBPID_STC_MC133USB = 0x0610;
		const unsigned short STCAM_USBPID_STC_MB152USB = 0x0710;
		const unsigned short STCAM_USBPID_STC_MC152USB = 0x0810;
		const unsigned short STCAM_USBPID_STC_MB202USB = 0x0910;
		const unsigned short STCAM_USBPID_STC_MC202USB = 0x1010;
		const unsigned short STCAM_USBPID_STC_MBA5MUSB3 = 0x0111;
		const unsigned short STCAM_USBPID_STC_MCA5MUSB3 = 0x0211;

		//------------------------------------------------------------------------------
		//AVI_STATUS
		//------------------------------------------------------------------------------
		const unsigned char STCAM_AVI_STATUS_STOP = 0x00;
		const unsigned char STCAM_AVI_STATUS_START = 0x01;
		const unsigned char STCAM_AVI_STATUS_PAUSE = 0x02;

		//------------------------------------------------------------------------------
		//DISPLAY_MODE
		//------------------------------------------------------------------------------
		const unsigned char STCAM_DISPLAY_MODE_GDI = 0x00;
		const unsigned char STCAM_DISPLAY_MODE_GDI_HALFTONE = 0x08;
		const unsigned char STCAM_DISPLAY_MODE_DD_OFFSCREEN = 0x01;
		const unsigned char STCAM_DISPLAY_MODE_DD_OVERLAY = 0x02;
		const unsigned char STCAM_DISPLAY_MODE_DD_OFFSCREEN_HQ = 0x03;
		const unsigned char STCAM_DISPLAY_MODE_DD_OVERLAY_HQ = 0x04;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX = 0x05;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX_VSYNC_ON = 0x06;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX_VSYNC_ON2 = 0x07;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX_FPU = 0x09;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX_VSYNC_ON_FPU = 0x0A;
		const unsigned char STCAM_DISPLAY_MODE_DIRECTX_VSYNC_ON2_FPU = 0x0B;

		//------------------------------------------------------------------------------
		//TRUE_FALSE
		//------------------------------------------------------------------------------
		const unsigned int STCAM_TRUE = 0xFFFFFFFF;
		const unsigned int STCAM_FALSE = 0x00000000;

		//------------------------------------------------------------------------------
		//CAMERA_SETTING
		//------------------------------------------------------------------------------
		const unsigned short STCAM_CAMERA_SETTING_INITIALIZE = 0x8000;
		const unsigned short STCAM_CAMERA_SETTING_WRITE = 0x2000;
		const unsigned short STCAM_CAMERA_SETTING_READ = 0x1000;
		const unsigned short STCAM_CAMERA_SETTING_STANDARD = 0x0800;
		const unsigned short STCAM_CAMERA_SETTING_DEFECT_PIXEL_POSITION = 0x0400;

		//------------------------------------------------------------------------------
		//DEFECT_PIXEL_CORRECTION
		//------------------------------------------------------------------------------
		const unsigned short STCAM_DEFECT_PIXEL_CORRECTION_OFF = 0x0000;
		const unsigned short STCAM_DEFECT_PIXEL_CORRECTION_ON = 0x0001;

		//------------------------------------------------------------------------------
		//BINNING_SUM
		//------------------------------------------------------------------------------
		const unsigned short STCAM_BINNING_SUM_MODE_OFF = 0x0000;
		const unsigned short STCAM_BINNING_SUM_MODE_H = 0x0001;

		//------------------------------------------------------------------------------
		//WINDOW_STYLE
		//------------------------------------------------------------------------------
		const unsigned int WS_OVERLAPPED = 0x00000000;
		const unsigned int WS_POPUP = 0x80000000;
		const unsigned int WS_CHILD = 0x40000000;
		const unsigned int WS_MINIMIZE = 0x20000000;
		const unsigned int WS_VISIBLE = 0x10000000;
		const unsigned int WS_DISABLED = 0x08000000;
		const unsigned int WS_CLIPSIBLINGS = 0x04000000;
		const unsigned int WS_CLIPCHILDREN = 0x02000000;
		const unsigned int WS_MAXIMIZE = 0x01000000;
		const unsigned int WS_CAPTION = 0x00C00000;
		const unsigned int WS_BORDER = 0x00800000;
		const unsigned int WS_DLGFRAME = 0x00400000;
		const unsigned int WS_VSCROLL = 0x00200000;
		const unsigned int WS_HSCROLL = 0x00100000;
		const unsigned int WS_SYSMENU = 0x00080000;
		const unsigned int WS_THICKFRAME = 0x00040000;
		const unsigned int WS_GROUP = 0x00020000;
		const unsigned int WS_TABSTOP = 0x00010000;
		const unsigned int WS_MINIMIZEBOX = 0x00020000;
		const unsigned int WS_MAXIMIZEBOX = 0x00010000;
		const unsigned int WS_OVERLAPPEDWINDOW = 0x00CF0000;
		const unsigned int WS_POPUPWINDOW = 0x80880000;
		const unsigned int WS_TILED = 0x00000000;
		const unsigned int WS_ICONIC = 0x00020000;
		const unsigned int WS_SIZEBOX = 0x00040000;
		const unsigned int WS_TILEDWINDOW = 0x00CF0000;
		const unsigned int WS_CHILDWINDOW = 0x40000000;
	}
}

